﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace GeoMapMarkers
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public List<MyShape> Shapes { get; set; }
        public MainWindow()
        {
            InitializeComponent();

            Shapes = new List<MyShape>();
            Shapes.Add(new MyShape()
            {
                Points = new List<List<Point>>(),
                Name = "test"
            });

            Shapes[0].Points.Add(new List<Point>()
            {
                new Point(0, 0),
            });

            DataContext = this;
        }
    }

    public class MyShape
    {
        public string Name { get; set; }
        public List<List<Point>> Points { get; set; }
    }

public class MyMarkerSelector : DataTemplateSelector
{
    public override DataTemplate SelectTemplate(object item, DependencyObject container)
    {
        Infragistics.Controls.Charts.DataContext dc = (Infragistics.Controls.Charts.DataContext)item;
        var series = dc.Series as Series;
        var markerType = MarkerSeries.ResolveMarkerType(series, (series as MarkerSeries).MarkerType);
        switch (markerType)
        {
            case MarkerType.Circle:
                return series.SeriesViewer.CircleMarkerTemplate;
            case MarkerType.Diamond:
                return series.SeriesViewer.DiamondMarkerTemplate;
            case MarkerType.Hexagon:
                return series.SeriesViewer.HexagonMarkerTemplate;
            case MarkerType.Hexagram:
                return series.SeriesViewer.HexagramMarkerTemplate;
            case MarkerType.None:
                return base.SelectTemplate(item, container);
            case MarkerType.Pentagon:
                return series.SeriesViewer.PentagonMarkerTemplate;
            case MarkerType.Pentagram:
                return series.SeriesViewer.PentagramMarkerTemplate;
            case MarkerType.Pyramid:
                return series.SeriesViewer.PyramidMarkerTemplate;
            case MarkerType.Square:
                return series.SeriesViewer.SquareMarkerTemplate;
            case MarkerType.Tetragram:
                return series.SeriesViewer.TetragramMarkerTemplate;
            case MarkerType.Triangle:
                return series.SeriesViewer.TriangleMarkerTemplate;
        }

        return base.SelectTemplate(item, container);
    }
}
}
